package jp.mosp.payroll.bonus.action;

import java.util.Date;
import java.util.List;

import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.kintai.common.dao.MKihonDao;
import jp.mosp.payroll.base.PayrollAction;
import jp.mosp.payroll.base.PayrollConst;
import jp.mosp.payroll.bonus.BonusConst;
import jp.mosp.payroll.bonus.dao.BonusListDao;
import jp.mosp.payroll.bonus.dao.PhBounsDao;
import jp.mosp.payroll.bonus.dto.BonusListDto;
import jp.mosp.payroll.bonus.vo.BonusListVo;
import jp.mosp.payroll.dao.PtCurrentDao;
import jp.mosp.payroll.dto.PtCurrentDto;

/**
 * 賞与データ一覧画面における処理を行う。<br><br>
 * 以下のコマンドを扱う。
 * <ul><li>
 * {@link #CMD_SHOW}
 * </li><li>
 * {@link #CMD_SEARCH}
 * </li><li>
 * {@link #CMD_RE_SEARCH}
 * </li><li>
 * {@link #CMD_SORT}
 * </li><li>
 * {@link #CMD_PAGE}
 * </li></ul>
 */
public class BonusListAction extends PayrollAction {
	
	/**
	 * 画面表示コマンド。<br><br>
	 * 賞与計算中の年月日を取得、表示する。<br>
	 * もし賞与計算中の年月日がなかった場合は、システム年月日を表示する。<br>
	 */
	public static final String	CMD_SHOW		= "P2021";
	
	/**
	 * 検索コマンド。<br><br>
	 * 指定された条件で給与データの検索を行い、一覧表示する。<br>
	 */
	public static final String	CMD_SEARCH		= "P2022";
	
	/**
	 * 再検索コマンド。<br><br>
	 * 保存された条件で給与データの検索を行い、一覧表示する。<br>
	 */
	public static final String	CMD_RE_SEARCH	= "P2023";
	
	/**
	 * ソートコマンド。<br><br>
	 * 指定された条件で給与データの並べ替えを行い、一覧表示する。<br>
	 */
	public static final String	CMD_SORT		= "P2024";
	
	/**
	 * ページコマンド。<br><br>
	 * 指定された条件で給与データのページ繰りを行い、一覧表示する。<br>
	 */
	public static final String	CMD_PAGE		= "P2025";
	

	/**
	 * Actionの初期化を行う。<br><br>
	 * 以下の処理を行う。
	 * <ul><li>
	 * {@link PayrollAction#PayrollAction()}
	 * </li></ul>
	 */
	public BonusListAction() {
		super();
	}
	
	/* (non-Javadoc)
	 * @see jp.mosp.common.common.BaseAction#getSpecificVo()
	 */
	@Override
	protected BaseVo getSpecificVo() {
		return new BonusListVo();
	}
	
	/**
	 * アクション。<br>
	 * 詳細は、クラス説明を参照。<br>
	 */
	public void action() throws Exception {
		// VO取得及び設定
		prepareVo();
		if (cmd.equals(CMD_SHOW)) {
			// 画面表示
			show();
		} else if (cmd.equals(CMD_SEARCH)) {
			// 検索処理
			search();
		} else if (cmd.equals(CMD_RE_SEARCH)) {
			// 再検索処理
			reSearch();
		} else if (cmd.equals(CMD_SORT)) {
			// ソート処理
			sort();
		} else if (cmd.equals(CMD_PAGE)) {
			// ページ処理
			page();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	/**
	 * 画面表示処理を行う。<br><br>
	 * @throws Exception 
	 */
	@Override
	public void show() throws Exception {
		// コネクション取得
		getConnection();
		// VO取得
		BonusListVo vo = (BonusListVo)getVo();
		// システム日付取得
		Date sysDate = new Date();
		// 計算中情報取得
		Date calcCurrent = getCalcCurrent();
		// プルダウンアイテム設定
		vo.setPitYear(getYearArrayLong(MospUtility.getYear(calcCurrent)));
		vo.setPitMonth(getMonthArray());
		vo.setPitDay(getDayArray());
		vo.setPitOffice(getOfficeArray());
		vo.setPitSection(getSectionArrayAll());
		vo.setPitPosition(getPositionArray());
		// 計算中情報確認
		if (calcCurrent == null) {
			// VOフィールド設定
			vo.setPltYear(MospUtility.getYear(sysDate));
			vo.setPltMonth(MospUtility.getMonth(sysDate));
			vo.setPltDay(MospUtility.getDay(sysDate));
			return;
		}
		// VOフィールド設定
		vo.setTxtKCode("");
		vo.setTxtKKana("");
		vo.setPltYear(MospUtility.getYear(calcCurrent));
		vo.setPltMonth(MospUtility.getMonth(calcCurrent));
		vo.setPltDay(MospUtility.getDay(calcCurrent));
		// リスト取得
		getList();
	}
	
	/**
	 * 検索処理を行う。
	 * @throws Exception 
	 */
	@Override
	public void search() throws Exception {
		// VO取得
		BonusListVo vo = (BonusListVo)getVo();
		// パラメータ取得
		vo.setParams(request);
		// リスト取得
		getList();
	}
	
	/**
	 * 	再検索処理を行う。
	 * @throws Exception 
	 */
	private void reSearch() throws Exception {
		// リスト取得
		getList();
	}
	
	/**
	 * ソート処理を行う。
	 * @throws Exception 
	 */
	private void sort() throws Exception {
		// VO取得
		BonusListVo vo = (BonusListVo)getVo();
		// ソート情報設定
		vo.setSortKey(key1);
		vo.setSelectIndex(1);
		// リスト取得
		getList();
	}
	
	/**
	 * ページ処理を行う。
	 * @throws Exception 
	 */
	private void page() throws Exception {
		// VO取得
		BonusListVo vo = (BonusListVo)getVo();
		// ページ情報設定
		vo.setSelectIndex(Integer.parseInt(key1));
		// リスト取得
		getList();
	}
	
	/**
	 * リストを取得する。
	 * @throws Exception 
	 */
	private void getList() throws Exception {
		// コネクション取得
		getConnection();
		// VO取得
		BonusListVo vo = (BonusListVo)getVo();
		// 賞与支給日取得
		Date targetMonth = getDate(vo.getPltYear(), vo.getPltMonth(), vo.getPltDay());
		vo.setLblTargetMonth(MospUtility.getDateString(targetMonth, PayrollConst.FORMAT_DATE));
		// DAO準備
		BonusListDao dao = new BonusListDao(cfg, cmd, aspUser, user, conn);
		// 件数取得
		vo.setCountAllData(dao.countForBonusList(vo.getTxtKCode(), vo.getTxtKKana(), vo.getPltOffice(), vo
			.getPltSection(), vo.getPltPosition(), targetMonth));
		// 検索
		List<BonusListDto> list = dao.findForPaymentList(vo.getTxtKCode(), vo.getTxtKKana(), vo.getPltOffice(), vo
			.getPltSection(), vo.getPltPosition(), targetMonth, getSortKey(), vo.getIsAscending(), vo.getDataPerPage(),
				vo.getOffset());
		// 名称取得用配列取得
		String[][] aryOffice = getOfficeArrayAll();
		String[][] arySection = getSectionArrayAll();
		String[][] aryPosition = getPositionArrayAll();
		// コード変換
		for (BonusListDto dto : list) {
			dto.setOfficeName(getCodeName(dto.getJCode(), aryOffice));
			dto.setSectionName(getCodeName(dto.getSCode(), arySection));
			dto.setPositionName(getCodeName(dto.getYCode(), aryPosition));
		}
		// VOに設定
		vo.setFields(list);
		// 対象が無かった場合のメッセージ設定
		if (vo.getCount() == 0) {
			vo.addErrMessage(MospUtility.getMessage(msg, MospConst.MSG_NO_DATA, ""));
		}
	}
	
	/**
	 * ソートキーを取得する。<br>
	 * @return ソートキー
	 */
	private String getSortKey() {
		// VO取得
		BonusListVo vo = (BonusListVo)getVo();
		// 選択キー取得
		String selectKey = vo.getSelectKey();
		// ソートキー取得
		String sortKey = PhBounsDao.TABLE + "." + PhBounsDao.COL_KCODE;
		if (selectKey == null) {
			// 処理無し
		} else if (selectKey.equals("2")) {
			sortKey = MKihonDao.COL_FURIGANA;
		} else if (selectKey.equals("3")) {
			sortKey = MKihonDao.COL_JCODE;
		} else if (selectKey.equals("4")) {
			sortKey = MKihonDao.COL_SCODE;
		} else if (selectKey.equals("5")) {
			sortKey = MKihonDao.COL_YCODE;
		} else if (selectKey.equals("6")) {
			sortKey = PhBounsDao.COL_PAYMENT_TOTAL;
		}
		return sortKey;
	}
	
	/**---- ↓↓各BonusActionで実装（共通化したい）:継承関係ができた場合は削除 ----**/
	
	/**
	 * 計算月取得
	 * @return 計算月
	 * @throws Exception
	 */
	@Override
	protected Date getCalcCurrent() throws Exception {
		// DAO準備
		PtCurrentDao dao = new PtCurrentDao(cfg, cmd, aspUser, user, conn);
		dao.initDao(cfg, cmd, aspUser, user, conn);
		PtCurrentDto dto = dao.findForKey(PayrollConst.OFFICE_ALL, PayrollConst.CALC_BONUS, getCurrent(
				PayrollConst.OFFICE_ALL, PayrollConst.CALC_PAYMENT));
		if (dto != null) {
			return dto.getCalcDate();
		}
		return new Date();
	}
	
	/**
	 * 年プルダウン取得(前後はBonusConstで指定)
	 * @param year 基準年
	 * @return 年プルダウン用文字列配列
	 */
	protected String[][] getYearArrayLong(int year) {
		return getYearArray(year, BonusConst.TIME_YEAR_FORMER, BonusConst.TIME_YEAR_FURTHER);
	}
	
	/**
	 * 年プルダウン取得
	 * @param year 基準年
	 * @return 年プルダウン用文字列配列
	 */
	protected String[][] getYearArray(int year, int former, int further) {
		String[][] aryYear = new String[former + further + 1][2];
		int i = 0;
		int index = 0;
		for (i = year - former; i < year; i++) {
			aryYear[index][0] = String.valueOf(i);
			aryYear[index][1] = String.valueOf(i);
			index++;
		}
		aryYear[index][0] = String.valueOf(year);
		aryYear[index][1] = String.valueOf(year);
		index++;
		for (i = year + 1; i <= year + further; i++) {
			aryYear[index][0] = String.valueOf(i);
			aryYear[index][1] = String.valueOf(i);
			index++;
		}
		return aryYear;
	}
	
}
